<template>
  <div class="card" :class="classes"  :style="styles">
    <div class="card__favourite-btn" @click="favToggle"><icon-like size="large" :filled="isInFavourite(src)" color="#ffffff" /></div>
    <div class="card__title" v-text="name"></div>
  </div>
</template>

<script>
import IconLike from './icons/IconLike'
import { mapGetters } from 'vuex'
export default {
  components: { IconLike },
  props: {
    src: {
      type: String,
      required: true
    },
    name: {
      type: String,
      required: true
    },
    size: {
      type: Number,
      default: 1
    }
  },
  computed: {
    ...mapGetters(['isInFavourite']),
    classes () {
      return [`card--size-${this.size}`]
    },
    styles () {
      let gradient

      if (this.size === 1) {
        gradient = 'linear-gradient(1deg, #000000 -5.53%, rgba(0, 0, 0, 0) 54.45%)'
      } else {
        gradient = 'linear-gradient(1.42deg, #000000 -15.62%, rgba(0, 0, 0, 0) 45.69%)'
      }
      return {
        'background-image': `${gradient}, url(${this.src})`
      }
    }
  },
  methods: {
    favToggle () {
      this.$store.commit('TOGGLE_FAVOURITE', this.src)
    }
  }
}
</script>

<style lang="scss">
.card {
  position: relative;
  background-size: cover !important;
  background-size: center center !important;
  width: 100%;
  height: 290px;
  border-radius: 8px;

  &--size-3 {
    grid-row: 1;
    grid-column: 1 / 4;
    height: 513px;

  .card__title {
      right: 50px;
     bottom: 50px;
     font-size: 30px;
    line-height: 28px;
  }
  .card__favourite-btn {
      left: 35px;
      top: 35px;
    }
  }

  &__title,
  &__favourite-btn {
    position: absolute;
  }

  &__title {
    right: 25px;
     bottom: 25px;
    text-transform: capitalize;
    font-weight: 600;
    font-size: 25px;
    line-height: 28px;
  }
  &__favourite-btn {
    left: 25px;
    top: 25px;
    cursor: pointer;
  }
}
</style>
